<template src="./template.html"></template>

<script lang="ts">
import { Watch, getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import _, { cloneDeep } from "lodash";
import { IItemListDiscount, ISellerDiscount } from "~/interfaces/discount";
import { getTimeZone } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");

function deepEqual(obj1: any, obj2: any) {
  return JSON.stringify(obj1) === JSON.stringify(obj2);
}

interface IBodyCreate {
  storeId: string;
  code: string;
  discount: number;
  minAmount: number;
  minQuantity: number;
  status: boolean;
  discountType: number;
  dateFrom: string;
  dateTo?: string;
  multipleReq?: IItemListDiscount[];
}

@Component({})
export default class AdminDiscountCreateComponent extends Vue {
  @Prop()
  tab!: number;

  // listMinimumRequire: IItemListDiscount[] = [];
  get isNotChangeListMinimum() {
    return this.$store.state.sellerStore.isNotChangeListMinimum;
  }
  set isNotChangeListMinimum(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeListMinimum", value);
  }
  get listMinimumRequire() {
    return this.$store.state?.sellerStore.listMinimumRequire || [];
  }
  get cloneListMinimumRequire() {
    return this.$store.state?.sellerStore.cloneListMinimumRequire || [];
  }
  set listMinimumRequire(val: any) {
    this.$store.commit("sellerStore/setListMinimumRequire", val);
  }

  get isNotChangeDiscount() {
    return this.$store.state?.sellerStore.isNotChangeDiscount || false;
  }

  set isNotChangeDiscount(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDiscount", val);
  }

  get cloneDiscount() {
    return this.$store.state?.sellerStore.cloneDiscount || [];
  }
  set cloneDiscount(value: any) {
    this.$store.commit("sellerStore/setCloneDiscount", value);
  }
  get discount() {
    return cloneDeep(this.$store.state?.sellerStore.discount) || [];
  }
  set discount(val: any) {
    this.$store.commit("sellerStore/setDiscount", val);
  }

  get isChanged() {
    return this.$store.state?.sellerStore.isChanged || false;
  }
  set isChanged(val: boolean) {
    this.$store.commit("sellerStore/setIsChanged", val);
  }
  // discount = {
  //   code: "",
  //   discount: 0,
  //   status: "true",
  //   discountType: "1",
  //   minAmount: 0,
  //   minQuantity: 0,
  // };

  setDiscountToStore() {
    this.$store.commit("sellerStore/setDiscount", this.discount);
    this.isNotChangeDiscount = deepEqual(this.discount, this.cloneDiscount);
  }

  get checkboxMinimum() {
    return this.$store.state?.sellerStore.checkboxMinimum || "1";
  }

  set checkboxMinimum(val: string) {
    this.$store.commit("sellerStore/setCheckboxMinimum", val);
  }

  get cloneCheckboxMinimum() {
    return this.$store.state?.sellerStore.cloneCheckboxMinimum || "1";
  }

  set cloneCheckboxMinimum(val: string) {
    this.$store.commit("sellerStore/setCloneCheckboxMinimum", val);
  }

  get isNotChangeCheckboxMinimum() {
    return this.$store.state?.sellerStore.isNotChangeCheckboxMinimum || false;
  }

  set isNotChangeCheckboxMinimum(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeCheckboxMinimum", val);
  }

  get isNotChangeMinimumRequire() {
    return this.$store.state?.sellerStore.isNotChangeMinimumRequire || false;
  }

  set isNotChangeMinimumRequire(val: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeMinimumRequire", val);
  }

  get minimumRequire() {
    return this.$store.state?.sellerStore.minimumRequire || 0;
  }

  set minimumRequire(value: any) {
    this.$store.commit("sellerStore/setMinimumRequire", value);
  }

  get cloneMinimumRequire() {
    return this.$store.state?.sellerStore.cloneMinimumRequire || 0;
  }

  set cloneMinimumRequire(value: any) {
    this.$store.commit("sellerStore/setCloneMinimumRequire", value);
  }

  checkboxMinimumDialog = "1";
  minimumRequireDialog = 0;

  discountCheck = {
    code: "",
    discount: 0,
    status: "true",
    discountType: "1",
    minAmount: 0,
    minQuantity: 0,
  };

  discountMinimum = {
    discountType: "1",
    discount: 0,
    minAmount: 0,
    minQuantity: 0,
    status: "true",
  };

  get isShowDateEnd() {
    return this.$store.state?.sellerStore.isShowDateEnd;
  }

  set isShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsShowDateEnd", value);
  }

  get cloneIsShowDateEnd() {
    return this.$store.state?.sellerStore.cloneIsShowDateEnd;
  }

  set cloneIsShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setCloneIsShowDateEnd", value);
  }

  get isNotChangeShowDateEnd() {
    return this.$store.state?.sellerStore.isNotChangeShowDateEnd;
  }

  set isNotChangeShowDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeShowDateEnd", value);
  }

  dateStartPicker = false;
  dateEndPicker = false;
  // dateStart = momentz
  //   .tz(this.timezoneCountry)
  //   .endOf("day")
  //   .format("YYYY-MM-DD");

  get dateStart() {
    return this.$store.state?.sellerStore.dateStart || "";
  }

  set dateStart(value: string) {
    this.$store.commit("sellerStore/setDateStart", value);
  }

  get isNotChangeDateStart() {
    return this.$store.state?.sellerStore.isNotChangeDateStart || false;
  }

  set isNotChangeDateStart(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDateStart", value);
  }

  get cloneDateStart() {
    return this.$store.state?.sellerStore.cloneDateStart || "";
  }

  get dateEnd() {
    return this.$store.state?.sellerStore.dateEnd || "";
  }

  set dateEnd(value: any) {
    this.$store.commit("sellerStore/setDateEnd", value);
  }
  get isNotChangeDateEnd() {
    return this.$store.state?.sellerStore.isNotChangeDateEnd || false;
  }

  set isNotChangeDateEnd(value: boolean) {
    this.$store.commit("sellerStore/setIsNotChangeDateEnd", value);
  }

  get cloneDateEnd() {
    return this.$store.state?.sellerStore.cloneDateEnd || "";
  }

  set cloneDateEnd(value: any) {
    this.$store.commit("sellerStore/setCloneDateEnd", value);
  }

  // dateEnd = momentz
  //   .tz(this.timezoneCountry)
  //   .endOf("month")
  //   .format("YYYY-MM-DD");

  menuTimePickerStart = false;
  menuTimePickerEnd = false;

  // timePickerStart = momentz.tz(this.timezoneCountry).format("HH:mm");

  get timePickerStart() {
    return this.$store.state?.sellerStore.timePickerStart || "";
  }

  set timePickerStart(value: any) {
    this.$store.commit("sellerStore/setTimePickerStart", value);
  }

  get cloneTimePickerStart() {
    return this.$store.state?.sellerStore.cloneTimePickerStart || "";
  }

  set cloneTimePickerStart(value: any) {
    this.$store.commit("sellerStore/setCloneTimePickerStart", value);
  }
  get isNotChangeTimePickerStart() {
    return this.$store.state?.sellerStore.isNotChangeTimePickerStart || false;
  }

  set isNotChangeTimePickerStart(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeTimePickerStart", value);
  }

  get timePickerEnd() {
    return this.$store.state?.sellerStore.timePickerEnd || "";
  }

  set timePickerEnd(value: any) {
    this.$store.commit("sellerStore/setTimePickerEnd", value);
  }
  get cloneTimePickerEnd() {
    return this.$store.state?.sellerStore.cloneTimePickerEnd || "";
  }

  set cloneTimePickerEnd(value: any) {
    this.$store.commit("sellerStore/setCloneTimePickerEnd", value);
  }

  get isNotChangeTimePickerEnd() {
    return this.$store.state?.sellerStore.isNotChangeTimePickerEnd || false;
  }

  set isNotChangeTimePickerEnd(value: any) {
    this.$store.commit("sellerStore/setIsNotChangeTimePickerEnd", value);
  }

  // timePickerEnd = momentz.tz(this.timezoneCountry).format("HH:mm");

  dialogAddMinimunRequire = false;
  dialogEditMinimunRequire = false;
  loadingTable = false;
  loading = false;

  discountId = "";
  idxItemListRequire = 0;

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get timezone() {
    return this.$store.state.setting.siteInfo.timezone || "-7";
  }

  get timezoneCountry() {
    return getTimeZone(this.$store.state.setting.timezone) || "US/Arizona";
  }

  get storeId() {
    return this.$store.state.sellerStore.storeId;
  }

  created() {
    this.onSetTime();
  }

  mounted() {}

  openDialogAddRequire() {
    this.dialogAddMinimunRequire = true;
    this.discountMinimum = {
      discountType: "1",
      discount: 0,
      minAmount: 0,
      minQuantity: 0,
      status: "true",
    };
    this.checkboxMinimumDialog = "1";
    this.minimumRequireDialog = 0;
  }

  openDialogEditRequire(item: IItemListDiscount, i: number) {
    this.idxItemListRequire = i;
    this.discountMinimum = {
      ...item,
      discountType: `${item.discountType}`,
      status: `${item.status}`,
    };
    if (item.minAmount === 0 && item.minQuantity === 0) {
      this.checkboxMinimumDialog = "1";
      this.minimumRequireDialog = 0;
    }
    if (item.minAmount > 0) {
      this.checkboxMinimumDialog = "2";
      this.minimumRequireDialog = item.minAmount;
    }
    if (item.minQuantity > 0) {
      this.checkboxMinimumDialog = "3";
      this.minimumRequireDialog = item.minQuantity;
    }
    this.dialogEditMinimunRequire = true;
  }

  onRemoveItemRequire(idx: number) {
    const listMinimumRequire = [...this.listMinimumRequire];
    listMinimumRequire.splice(idx, 1);
    this.$store.commit("sellerStore/setListMinimumRequire", listMinimumRequire);
    this.isNotChangeListMinimum = deepEqual(
      this.listMinimumRequire,
      this.cloneListMinimumRequire
    );
  }

  onCheckDifferenceData() {
    if (this.discountId) {
      if (_.isEqual(this.discount, this.discountCheck)) {
        this.isChanged = false;
      } else {
        this.isChanged = true;
      }
    }
  }

  onAddRequire() {
    if (
      this.discountMinimum.discountType !== "3" &&
      !this.discountMinimum.discount
    ) {
      return this.$pushNotification.error("Please enter discount value");
    } else if (
      this.discountMinimum.discountType === "1" &&
      (this.discountMinimum.discount < 0 || this.discountMinimum.discount > 100)
    ) {
      return this.$pushNotification.error(
        "Discount value cannot be less than 0 and greater than 100"
      );
    }

    this.$store.commit("sellerStore/setListMinimumRequire", [
      ...this.listMinimumRequire,
      {
        ...this.discountMinimum,
        minAmount:
          this.checkboxMinimumDialog === "2" ? this.minimumRequireDialog : 0,
        minQuantity:
          this.checkboxMinimumDialog === "3" ? this.minimumRequireDialog : 0,
        status: eval(this.discountMinimum.status),
        discountType: eval(this.discountMinimum.discountType),
      },
    ]);

    this.dialogAddMinimunRequire = false;
    this.discountMinimum = {
      discountType: "1",
      discount: 0,
      minAmount: 0,
      minQuantity: 0,
      status: "true",
    };
    this.isChanged = true;
    this.isNotChangeListMinimum = deepEqual(
      this.listMinimumRequire,
      this.cloneListMinimumRequire
    );
  }

  onEditRequire() {
    this.listMinimumRequire[this.idxItemListRequire] = this.discountMinimum;
    if (this.checkboxMinimumDialog === "1") {
      this.discountMinimum.minAmount = 0;
      this.discountMinimum.minQuantity = 0;
    }
    if (this.checkboxMinimumDialog === "2") {
      this.discountMinimum.minAmount = this.minimumRequireDialog;
      this.discountMinimum.minQuantity = 0;
    }
    if (this.checkboxMinimumDialog === "3") {
      this.discountMinimum.minAmount = 0;
      this.discountMinimum.minQuantity = this.minimumRequireDialog;
    }
    this.dialogEditMinimunRequire = false;
    this.isChanged = true;
  }

  onSetTime() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
      timeFrom: this.timePickerStart,
      timeTo: this.timePickerEnd,
    });
  }

  onDiscard() {
    this.$store.dispatch("sellerStore/onGetDiscount", {
      ctx: this,
      dontLoading: true,
    });
    this.isChanged = false;
  }

  @Watch("dateStart")
  onChagedDateStart() {
    this.onSetTime();
  }

  @Watch("dateEnd")
  onChagedDateEnd() {
    this.onSetTime();
  }

  @Watch("timePickerStart")
  onChagedTimeStart() {
    this.onSetTime();
  }

  @Watch("timePickerEnd")
  onChagedTimeEnd() {
    this.onSetTime();
  }

  @Watch("discount.code")
  changedCodeName(value: string) {
    if (value) {
      this.discount.code = value.toLocaleUpperCase();
    }
  }

  @Watch("tab")
  changedTab(value: number) {
    if (value === 7) {
      this.$store.dispatch("sellerStore/onGetDiscount", {
        ctx: this,
      });
    }
  }

  @Watch("checkboxMinimum")
  changeIsNotChangeCheckboxMinimum(value: string) {
    if (value) {
      this.isNotChangeCheckboxMinimum = deepEqual(
        this.checkboxMinimum,
        this.cloneCheckboxMinimum
      );
    }
  }

  @Watch("minimumRequire")
  changeIsNotChangeMinimumRequire(value: number) {
    if (value) {
      this.isNotChangeMinimumRequire = deepEqual(
        this.minimumRequire,
        this.cloneMinimumRequire
      );
    }
  }

  @Watch("dateStart")
  changeDateStart(value: any) {
    if (value) {
      this.isNotChangeDateStart = deepEqual(
        this.dateStart,
        this.cloneDateStart
      );
    }
  }

  @Watch("dateEnd")
  changeDateEnd(value: any) {
    if (value) {
      this.isNotChangeDateEnd = deepEqual(this.dateEnd, this.cloneDateEnd);
    }
  }

  @Watch("timePickerStart")
  changeTimePickerStart(value: any) {
    if (value) {
      this.isNotChangeTimePickerEnd = deepEqual(
        this.timePickerStart,
        this.cloneTimePickerStart
      );
    }
  }

  @Watch("timePickerEnd")
  changeTimePickerEnd(value: any) {
    if (value) {
      this.isNotChangeTimePickerEnd = deepEqual(
        this.timePickerEnd,
        this.cloneTimePickerEnd
      );
    }
  }

  @Watch("isShowDateEnd")
  changeIsShowDateEnd() {
    this.isNotChangeShowDateEnd = deepEqual(
      this.isShowDateEnd,
      this.cloneIsShowDateEnd
    );
  }
}
</script>

<style></style>
